package com.zhongzheng.modules.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.user.bo.UserBankQuestionRecordAddBo;
import com.zhongzheng.modules.user.bo.UserBankQuestionRecordEditBo;
import com.zhongzheng.modules.user.bo.UserBankQuestionRecordQueryBo;
import com.zhongzheng.modules.user.domain.UserBankQuestionRecord;
import com.zhongzheng.modules.user.mapper.UserBankQuestionRecordMapper;
import com.zhongzheng.modules.user.service.IUserBankQuestionRecordService;
import com.zhongzheng.modules.user.service.IUserPlanCourceService;
import com.zhongzheng.modules.user.vo.UserBankQuestionRecordVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 用户做的历史题库题目记录Service业务层处理
 *
 * @author ruoyi
 * @date 2021-06-24
 */
@Service
public class UserBankQuestionRecordServiceImpl extends ServiceImpl<UserBankQuestionRecordMapper, UserBankQuestionRecord> implements IUserBankQuestionRecordService {

    @Autowired
    private UserBankQuestionRecordMapper userBankQuestionRecordMapper;

    @Override
    public UserBankQuestionRecordVo queryById(Long replyId){
        UserBankQuestionRecord db = this.baseMapper.selectById(replyId);
        return BeanUtil.toBean(db, UserBankQuestionRecordVo.class);
    }

    @Override
    public List<UserBankQuestionRecordVo> queryList(UserBankQuestionRecordQueryBo bo) {
        LambdaQueryWrapper<UserBankQuestionRecord> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getRecordId() != null, UserBankQuestionRecord::getRecordId, bo.getRecordId());
        lqw.eq(bo.getQuestionId() != null, UserBankQuestionRecord::getQuestionId, bo.getQuestionId());
        lqw.eq(bo.getIsRight() != null, UserBankQuestionRecord::getIsRight, bo.getIsRight());
        lqw.eq(bo.getBankId() != null, UserBankQuestionRecord::getBankId, bo.getBankId());
        lqw.eq(StrUtil.isNotBlank(bo.getSelectIds()), UserBankQuestionRecord::getSelectIds, bo.getSelectIds());
        lqw.eq(StrUtil.isNotBlank(bo.getReplyStr()), UserBankQuestionRecord::getReplyStr, bo.getReplyStr());
        return entity2Vo(this.list(lqw));
    }

    @Override
    public List<UserBankQuestionRecordVo> queryWrongList(UserBankQuestionRecordQueryBo bo) {
        return userBankQuestionRecordMapper.queryWrongList(bo);
    }

    @Override
    public List<UserBankQuestionRecordVo> queryDoneList(UserBankQuestionRecordQueryBo bo) {
        return userBankQuestionRecordMapper.queryDoneList(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<UserBankQuestionRecordVo> entity2Vo(Collection<UserBankQuestionRecord> collection) {
        List<UserBankQuestionRecordVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, UserBankQuestionRecordVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<UserBankQuestionRecord> page = (Page<UserBankQuestionRecord>)collection;
            Page<UserBankQuestionRecordVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(UserBankQuestionRecordAddBo bo) {
        UserBankQuestionRecord add = BeanUtil.toBean(bo, UserBankQuestionRecord.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(UserBankQuestionRecordEditBo bo) {
        UserBankQuestionRecord update = BeanUtil.toBean(bo, UserBankQuestionRecord.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserBankQuestionRecord entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
